#!/usr/local/bin/python 
###
# calculate 2nd-order Mrakov model
#	base order : ACGT
# this is for Leave-one-out calculation
###
from Numeric import *

BG={}
#Background probabilit in Bsub: 0th order Markov Model
BG["A"] = 0.1672
BG["C"] = 0.3328
BG["G"] = 0.3328
BG["T"] = 0.1672
#Background probabilit in Bsub: 1st order Markov Model
BG["AA"] = 0.0301
BG["AC"] = 0.048
BG["AG"] = 0.0565
BG["AT"] = 0.0327
BG["CA"] = 0.0609
BG["CC"] = 0.0935
BG["CG"] = 0.1218
BG["CT"] = 0.0565
BG["GA"] = 0.0611
BG["GC"] = 0.1301
BG["GG"] = 0.0935
BG["GT"] = 0.048
BG["TA"] = 0.0151
BG["TC"] = 0.0611
BG["TG"] = 0.0609
BG["TT"] = 0.0301

#nexfile = open("align_nex/align_up32.nex","r")
nexfile = open("align_nex/align_dw22.nex","r")
nexdata = nexfile.readlines()
nexdata = nexdata[8:-4]
for i in range (len(nexdata)):
	nexdata[i] = nexdata[i].replace("\n","")
	nexdata[i] = nexdata[i].replace("\t","")
	nexdata[i] = nexdata[i].replace("'","")
	nexdata[i] = nexdata[i].split()

outfile = open("align_matrix_loo_1st/align_dw20.txt","w")
#initialization
N = {}
S = {}
for x in "ACGT":
	N[x] = zeros(32,Float)
	S[x] = zeros(32,Float)
	for y in "ACGT":
		N[x+y] = zeros(32,Float)
		S[x+y] = zeros(32,Float)

for i in range (len(nexdata)):
	for j in range(len(nexdata[i][-1])-1):
		for x in "ACGT":
			if(nexdata[i][-1][j] == x):
				N[x][j] += 1
			for y in "ACGT":
				if(nexdata[i][-1][j:j+2] == x+y):
					N[x+y][j] += 1

tnum = len(nexdata)-1
B = sqrt(tnum)
printout = ""
for i in range(len(nexdata[0][-1])-1)[1:]:	#[1:] : bacause original file is for 2nd order
	for x in "ACGT":
		S[x][i] = log(((N[x][i]+B*BG[x])/(tnum+B)) / BG[x])
		for y in "ACGT":
			S[x+y][i] = log(((N[x+y][i]+B*BG[x+y])/(tnum+B)) / BG[x+y]) - S[x][i]
			printout = printout + "%.4f\t" % (S[x+y][i])
	printout = printout[:-1]	#remove the last tab(\t)
	printout = printout + "\n"
printout = printout[:-1]	#remove the last return(\n)
outfile.write(printout)
	